"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.none = Symbol();
var MEMBER_TYPE = Symbol();
function makeTaggedUnion(defObj) {
    var MATCH_TYPE = Symbol("MATCH_TYPE");
    var MATCH_DATA = Symbol("MATCH_DATA");
    var TaggedUnionImpl = /** @class */ (function () {
        function TaggedUnionImpl(MatchType, data) {
            this[MATCH_TYPE] = MatchType;
            this[MATCH_DATA] = data;
        }
        TaggedUnionImpl.prototype.match = function (casesObj) {
            var data = this[MATCH_DATA];
            var matchingHandler = casesObj[this[MATCH_TYPE]];
            if (matchingHandler) {
                return matchingHandler(data);
            }
            else if (casesObj._) {
                return casesObj._(data);
            }
        };
        return TaggedUnionImpl;
    }());
    // @ts-ignore
    var matchObj = {};
    Object.keys(defObj).forEach(function (matchType) {
        var value = defObj[matchType];
        if (typeof value === "function") {
            // @ts-ignore
            matchObj[matchType] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var data = value.apply(void 0, args);
                // @ts-ignore
                return new TaggedUnionImpl(matchType, data);
            };
        }
        else {
            // @ts-ignore
            matchObj[matchType] = new TaggedUnionImpl(matchType);
        }
    });
    return matchObj;
}
exports.makeTaggedUnion = makeTaggedUnion;
